#include <stdio.h>

#include "wiringPi.h"
#include "sr595.h"

#define PIN_BASE 100
#define PIN_DATA 23
#define PIN_CLOCK 24
#define PIN_LATCH 25

#define LEDS 16
#define PWM_LOOPS 16

int main() {
	int rc;

	rc = wiringPiSetupGpio();
	if (rc != 0) {
		printf("Error setting up wiringPi");
		return rc;
	}

	rc = sr595Setup(PIN_BASE, LEDS, PIN_DATA, PIN_CLOCK, PIN_LATCH);
	if (rc != 0) {
		printf("Error setting up sr595");
		return rc;
	}

	for (;;) {
		int activeBit = 0;
		int increment = 1;

		for (;;) {
			for (int led = 0; led < LEDS; led++) {
				digitalWrite(PIN_BASE + led, activeBit == led ? 1 : 0);
			}

			activeBit += increment;

			if (activeBit == 0 || activeBit == LEDS - 1) {
				increment *= -1;
			}

			delay(80);
		}
	}

	return 0;
}
