#include <stdio.h>

#include "wiringPi.h"

#include "sequence.h"

#define PIN_BASE 100
#define PIN_DATA 23
#define PIN_CLOCK 24
#define PIN_LATCH 25

#define PWM_LOOPS 1024

int main() {
	int rc;

	rc = wiringPiSetupGpio();
	if (rc != 0) {
		printf("Error setting up wiringPi");
		return rc;
	}

	pinMode(PIN_DATA, OUTPUT);
	pinMode(PIN_CLOCK, OUTPUT);
	pinMode(PIN_LATCH, OUTPUT);

	digitalWrite(PIN_DATA, 0);
	digitalWrite(PIN_CLOCK, 0);
	digitalWrite(PIN_CLOCK, 1);

	for (;;) {
		for (int frame = 0; frame < FRAMES; frame++) {
			for (int loop = 0; loop < PWM_LOOPS; loop++) {
				for (int level = 0; level < 7; level++) {
					for (int led = 0; led < LEDS; led++) {
						digitalWrite(PIN_DATA,
								frames[frame][led] > level ? 1 : 0);
						digitalWrite(PIN_CLOCK, 1);
						digitalWrite(PIN_CLOCK, 0);
					}
					digitalWrite(PIN_LATCH, 1);
					digitalWrite(PIN_LATCH, 0);
				}
			}
		}
	}

	return 0;
}
